﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class Canvas_Manager : MonoBehaviour {
	public static Canvas_Manager Instance = null; // rende la classe un singleton
	private bool indietro = false; //gestisce il tasto backspace delle tastiere
	[SerializeField] private Canvas tastiera10, tastiera2, tastiera8, tastiera16, tastiera20, principale; //dichiarazione di ogni tastiera 

	void Awake () {
		Instance = this; // viere restituito l'oggetto instance
	}



	
	public void canvasAppear(Canvas canvas){ //fa apparire la tastiera passata come parametro
		allCanvasDisappear (); //disattiva tutte le tastiere
		if (!indietro) { //se il tasto "backspace" non è ancora visibile:
			indietro = true; // rendi visibile
			canvasAppear (principale);
		}
		canvas.GetComponent<CanvasGroup> ().alpha = 1f; //rende la tastiera visibile
		canvas.GetComponent<CanvasGroup> ().interactable = true; //rende la tastiera interagibile
		canvas.GetComponent<CanvasGroup> ().blocksRaycasts = true; //la tastiera ha la precedenza nel caso in cui ci siano piu tastiere sovrapposte
	}

	public void canvasAppear(){
		int numero = Operation.Instance.getBase (); //assegna alla variabile numero la base su cui stiamo operando prendendola dalla funzione getBase() della classe "Operation"
		Canvas canvas = getTastiera(numero); //l'oggetto canvas prende la tastiera tramite la funzione getTastiera spiegata in fondo
		allCanvasDisappear (); //vengono disattivate tutte le tastiere
		if (!indietro) { //se il tasto "backspace" non è ancora visibile:
			indietro = true; // rendi visibile
			canvasAppear (principale);
		}
		canvas.GetComponent<CanvasGroup> ().alpha = 1f; //rende la tastiera visibile
		canvas.GetComponent<CanvasGroup> ().interactable = true; //rende la tastiera interagibile
		canvas.GetComponent<CanvasGroup> ().blocksRaycasts = true; //la tastiera ha la precedenza nel caso in cui ci siano piu tastiere sovrapposte
	}

	void allCanvasDisappear(){ // disattiva tutte le tastiere
		canvasDisappear (tastiera10); //10
		canvasDisappear (tastiera2); //2
		canvasDisappear (tastiera8); //8
		canvasDisappear (tastiera16); //16
		canvasDisappear (tastiera20); //20
	}

	void canvasDisappear(Canvas canvas){//le tastiere disattivate:
		canvas.GetComponent<CanvasGroup> ().alpha = 0f; //rende la tastiera invisibile
		canvas.GetComponent<CanvasGroup> ().interactable = false;  //rende la tastiera non interagibile
		canvas.GetComponent<CanvasGroup> ().blocksRaycasts = false; //la tastiera non ha più la precedenza nel caso in cui ci siano piu tastiere sovrapposte
	}

	Canvas getTastiera(int numero){//il parametro numero prende gli interi "10,2,8,16,20" 
		switch (numero) { //a ogni dei 5 interi presi da numero associamo una tastiera
		case 10:
			return tastiera10; //10
		case 2:
			return tastiera2; //2
		case 8:
			return tastiera8; //8
		case 16:
			return tastiera16; //16
		case 20: 
			return tastiera20; //20
		}
		return null; //prende null se l'intero preso non rientra nei casi visti in precedenza
	}
}
